package biz.nellemann.libpaqle

import biz.nellemann.libpaqle.pojo.PaqleResponse
import okhttp3.HttpUrl
import okhttp3.mockwebserver.MockResponse
import okhttp3.mockwebserver.MockWebServer
import spock.lang.Specification

class PaqleSpec extends Specification {

    Paqle paqle
	MockWebServer mockServer = new MockWebServer();

    def setup() {
        paqle = new Paqle("TestCompany", "testUser", "testPassword")
		mockServer.start();
	}

    def cleanup() {
		mockServer.shutdown()
	}

	void "test succesfull parsing of test JSON"() {

		setup:
		def testFile = new File(getClass().getResource('/test.json').toURI())
		def testJson = testFile.getText('UTF-8')

		when:
		PaqleResponse response = paqle.getResponse(testJson)

		then:
		response.Entities.size() == 2
		response.News.size() == 100
	}

	void "test succesful HTTP GET 15027800"() {

		setup:
		mockServer.enqueue(new MockResponse().setBody("{}"));
		HttpUrl baseUrl = mockServer.url("/");
		paqle.baseUrl = baseUrl.toString()

		when:
		def jsonString = paqle.getJson(["15027800"])

		then:
		jsonString != null
		jsonString == "{}"
	}

}
